=== modified file 'mysys/default.cc'
--- mysys/default.cc	2009-04-17 21:01:47 +0000
+++ mysys/default.cc	2009-06-29 16:20:07 +0000
@@ -36,10 +36,11 @@
 #include "mysys/mysys_priv.h"
 #include <mystrings/m_string.h>
 #include <mystrings/m_ctype.h>
-#include <mysys/my_dir.h>
 #include <drizzled/configmake.h>
+#include <drizzled/gettext.h>
 
 #include <stdio.h>
+#include <dirent.h>
 
 const char *my_defaults_file=0;
 const char *my_defaults_group_suffix=0;
@@ -589,9 +590,9 @@
   FILE *fp;
   uint32_t line=0;
   bool found_group=0;
-  uint32_t i;
-  MY_DIR *search_dir;
-  FILEINFO *search_file;
+  DIR *dirp;
+  struct dirent dirent_entry;
+  struct dirent *dirent_result;
 
   if ((dir ? strlen(dir) : 0 )+strlen(config_file) >= FN_REFLEN-3)
     return 0;					/* Ignore wrong paths */
@@ -668,32 +669,40 @@
                                 ptr, name, line)))
 	  goto err;
 
-        if (!(search_dir= my_dir(ptr, MYF(MY_WME))))
+        if ((dirp= opendir(ptr)) == NULL)
+        {
+          /**
+           * @todo
+           * Since clients still use this code, we use fprintf here.
+           * This fprintf needs to be turned into errmsg_printf
+           * as soon as the client programs no longer use mysys
+           * and can use the pluggable error message system.
+           */
+          fprintf(stderr, _("error: could not open directory: %s\n"), ptr);
           goto err;
-
-        for (i= 0; i < (uint32_t) search_dir->number_off_files; i++)
+        }
+
+        int rc= readdir_r(dirp, &dirent_entry, &dirent_result);
+
+        while (!rc && (dirent_result != NULL))
         {
-          search_file= search_dir->dir_entry + i;
-          ext= fn_ext(search_file->name);
+          ext= fn_ext(dirent_entry.d_name);
 
           /* check extension */
           for (tmp_ext= (char**) f_extensions; *tmp_ext; tmp_ext++)
           {
             if (!strcmp(ext, *tmp_ext))
-              break;
-          }
-
-          if (*tmp_ext)
-          {
-            fn_format(tmp, search_file->name, ptr, "",
-                      MY_UNPACK_FILENAME | MY_SAFE_PATH);
-
-            search_default_file_with_ext(opt_handler, handler_ctx, "", "", tmp,
-                                         recursion_level + 1);
-          }
+            {
+              fn_format(tmp, dirent_entry.d_name, ptr, "",
+                        MY_UNPACK_FILENAME | MY_SAFE_PATH);
+
+              search_default_file_with_ext(opt_handler, handler_ctx, "", "",
+                                           tmp, recursion_level + 1);
+            }
+          }
+
+          rc= readdir_r(dirp, &dirent_entry, &dirent_result);
         }
-
-        my_dirend(search_dir);
       }
       else if ((!strncmp(ptr, include_keyword, sizeof(include_keyword) - 1)) &&
                my_isspace(&my_charset_utf8_general_ci, ptr[sizeof(include_keyword)-1]))

